Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Views/3.4/HiveEngineView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Views/3.4/HiveEngineView.Designer.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Views/3.4/HiveEngineView.Designer.cs	(revision 6381)
@@ -33,5 +33,5 @@
       this.tabControl = new System.Windows.Forms.TabControl();
       this.jobsTabPage = new System.Windows.Forms.TabPage();
-      this.hiveExperimentListView = new HiveExperimentListView();
+      this.hiveExperimentListView = new HeuristicLab.Clients.Hive.ExperimentManager.Views.RefreshableHiveExperimentListView();
       this.logTabPage = new System.Windows.Forms.TabPage();
       this.logView = new HeuristicLab.Core.Views.LogView();
@@ -39,4 +39,5 @@
       this.executionTimeTextBox = new System.Windows.Forms.TextBox();
       this.useLocalPluginsCheckBox = new System.Windows.Forms.CheckBox();
+      this.isPrivilegedCheckBox = new System.Windows.Forms.CheckBox();
       this.tabControl.SuspendLayout();
       this.jobsTabPage.SuspendLayout();
@@ -60,5 +61,5 @@
       this.resourceIdsTextBox.Location = new System.Drawing.Point(189, 52);
       this.resourceIdsTextBox.Name = "resourceIdsTextBox";
-      this.resourceIdsTextBox.Size = new System.Drawing.Size(405, 20);
+      this.resourceIdsTextBox.Size = new System.Drawing.Size(319, 20);
       this.resourceIdsTextBox.TabIndex = 4;
       this.resourceIdsTextBox.Text = "HEAL";
@@ -184,16 +185,29 @@
       this.useLocalPluginsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.useLocalPluginsCheckBox.AutoSize = true;
-      this.useLocalPluginsCheckBox.Location = new System.Drawing.Point(600, 55);
+      this.useLocalPluginsCheckBox.Location = new System.Drawing.Point(598, 55);
       this.useLocalPluginsCheckBox.Name = "useLocalPluginsCheckBox";
-      this.useLocalPluginsCheckBox.Size = new System.Drawing.Size(103, 17);
+      this.useLocalPluginsCheckBox.Size = new System.Drawing.Size(105, 17);
       this.useLocalPluginsCheckBox.TabIndex = 12;
-      this.useLocalPluginsCheckBox.Text = "useLocalPlugins";
+      this.useLocalPluginsCheckBox.Text = "UseLocalPlugins";
       this.useLocalPluginsCheckBox.UseVisualStyleBackColor = true;
       this.useLocalPluginsCheckBox.CheckedChanged += new System.EventHandler(this.useLocalPluginsCheckBox_CheckedChanged);
       // 
+      // isPrivilegedCheckBox
+      // 
+      this.isPrivilegedCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.isPrivilegedCheckBox.AutoSize = true;
+      this.isPrivilegedCheckBox.Location = new System.Drawing.Point(514, 55);
+      this.isPrivilegedCheckBox.Name = "isPrivilegedCheckBox";
+      this.isPrivilegedCheckBox.Size = new System.Drawing.Size(80, 17);
+      this.isPrivilegedCheckBox.TabIndex = 13;
+      this.isPrivilegedCheckBox.Text = "IsPrivileged";
+      this.isPrivilegedCheckBox.UseVisualStyleBackColor = true;
+      this.isPrivilegedCheckBox.CheckedChanged += new System.EventHandler(this.isPrivilegedCheckBox_CheckedChanged);
+      // 
       // HiveEngineView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.isPrivilegedCheckBox);
       this.Controls.Add(this.useLocalPluginsCheckBox);
       this.Controls.Add(this.executionTimeTextBox);
@@ -231,5 +245,6 @@
     private System.Windows.Forms.CheckBox useLocalPluginsCheckBox;
     private HeuristicLab.Core.Views.LogView logView;
-    private HiveExperimentListView hiveExperimentListView;
+    private RefreshableHiveExperimentListView hiveExperimentListView;
+    private System.Windows.Forms.CheckBox isPrivilegedCheckBox;
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Views/3.4/HiveEngineView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Views/3.4/HiveEngineView.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Views/3.4/HiveEngineView.cs	(revision 6381)
@@ -74,4 +74,5 @@
         executionTimeOnHiveTextBox.Text = string.Empty;
         useLocalPluginsCheckBox.Checked = false;
+        isPrivilegedCheckBox.Checked = false;
         hiveExperimentListView.Content = null;
         logView.Content = null;
@@ -81,4 +82,5 @@
         executionTimeOnHiveTextBox.Text = Content.ExecutionTimeOnHive.ToString();
         useLocalPluginsCheckBox.Checked = Content.UseLocalPlugins;
+        isPrivilegedCheckBox.Checked = Content.IsPrivileged;
         hiveExperimentListView.Content = Content.HiveExperiments;
         logView.Content = Content.Log;
@@ -93,8 +95,10 @@
         priorityTextBox.ReadOnly = this.ReadOnly;
         useLocalPluginsCheckBox.Enabled = !this.ReadOnly;
+        isPrivilegedCheckBox.Enabled = !this.ReadOnly; // TODO: check for user rights
       } else {
         resourceIdsTextBox.ReadOnly = false;
         priorityTextBox.ReadOnly = false;
         useLocalPluginsCheckBox.Enabled = false;
+        isPrivilegedCheckBox.Enabled = false;
       }
     }
@@ -112,7 +116,9 @@
       Content.UseLocalPlugins = useLocalPluginsCheckBox.Checked;
     }
+
+    private void isPrivilegedCheckBox_CheckedChanged(object sender, EventArgs e) {
+      Content.IsPrivileged = isPrivilegedCheckBox.Checked;
+    }
     #endregion
-
-
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HiveEngine.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HiveEngine.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HiveEngine.cs	(revision 6381)
@@ -74,4 +74,11 @@
     }
 
+    [Storable]
+    private bool isPrivileged;
+    public bool IsPrivileged {
+      get { return isPrivileged; }
+      set { isPrivileged = value; }
+    }
+
     // [Storable] -> HiveExperiment can't be storable, so RefreshableHiveExperiment can't be stored
     private ItemCollection<RefreshableHiveExperiment> hiveExperiments = new ItemCollection<RefreshableHiveExperiment>();
@@ -108,4 +115,5 @@
       this.executionTimeOnHive = original.executionTimeOnHive;
       this.useLocalPlugins = original.useLocalPlugins;
+      this.IsPrivileged = original.IsPrivileged;
       // this.hiveExperiments = cloner.Clone(original.hiveExperiments); do not clone hiveExperiments - otherwise they would be sent with every job
     }
@@ -187,5 +195,5 @@
           //  }
           //} else if (coll.Parallel) {
-          if(coll.Parallel) {
+          if (coll.Parallel) {
             // clone the parent scope here and reuse it for each operation. otherwise for each job the whole scope-tree first needs to be copied and then cleaned, which causes a lot of work for the Garbage Collector
             IScope parentScopeClone = (IScope)((IAtomicOperation)coll.First()).Scope.Parent.Clone();
@@ -272,14 +280,12 @@
       IScope[] scopes = new Scope[jobs.Length];
       object locker = new object();
-      IDictionary<Guid, int> jobIndices = new Dictionary<Guid, int>();
       var hiveExperiment = refreshableHiveExperiment.HiveExperiment;
 
       try {
-        List<Guid> remainingJobIds = new List<Guid>();
-
         // create upload-tasks
-        var uploadTasks = new List<Task<Job>>();
         for (int i = 0; i < jobs.Length; i++) {
-          hiveExperiment.HiveJobs.Add(new EngineHiveJob(jobs[i], parentScopeClone));
+          var engineHiveJob = new EngineHiveJob(jobs[i], parentScopeClone);
+          engineHiveJob.Job.Priority = this.Priority;
+          hiveExperiment.HiveJobs.Add(engineHiveJob);
 
           // shuffle random variable to avoid the same random sequence in each operation; todo: does not yet work (it cannot find the random variable)
@@ -288,22 +294,22 @@
             random.Reset(random.Next());
         }
-        HiveClient.StartExperiment((e) => {
-          LogException(e);
-        }, refreshableHiveExperiment);
+        HiveClient.StartExperiment((e) => { LogException(e); }, refreshableHiveExperiment);
 
         // do polling until experiment is finished and all jobs are downloaded
         while (!refreshableHiveExperiment.AllJobsFinished()) {
-          Thread.Sleep(500);
+          Thread.Sleep(2000);
           this.ExecutionTimeOnHive = TimeSpan.FromMilliseconds(hiveExperiments.Sum(x => x.HiveExperiment.ExecutionTime.TotalMilliseconds));
           cancellationToken.ThrowIfCancellationRequested();
         }
         LogMessage(string.Format("{0} finished (TotalExecutionTime: {1}).", refreshableHiveExperiment.ToString(), refreshableHiveExperiment.HiveExperiment.ExecutionTime));
+
+        var failedJobs = hiveExperiment.HiveJobs.Where(x => x.Job.State == JobState.Failed);
+        if(failedJobs.Count() > 0) {
+          throw new HiveEngineException("Job failed: " + failedJobs.First().Job.StateLog.Last().Exception);
+        }
 
         // get scopes
         int j = 0;
         foreach (var hiveJob in hiveExperiment.HiveJobs) {
-          if (hiveJob.Job.State != JobState.Finished)
-            throw new HiveEngineException("Job failed: " + hiveJob.Job.StateLog.Last().Exception);
-
           var scope = ((IAtomicOperation)((EngineJob)hiveJob.ItemJob).InitialOperation).Scope;
           scopes[j++] = scope;
@@ -313,5 +319,5 @@
       catch (OperationCanceledException e) {
         lock (locker) {
-          if (jobIndices != null) DeleteHiveExperiment(hiveExperiment.Id);
+          DeleteHiveExperiment(hiveExperiment.Id);
         }
         throw e;
@@ -319,5 +325,5 @@
       catch (Exception e) {
         lock (locker) {
-          if (jobIndices != null) DeleteHiveExperiment(hiveExperiment.Id);
+          DeleteHiveExperiment(hiveExperiment.Id);
         }
         LogException(e);
@@ -333,4 +339,5 @@
         hiveExperiment.UseLocalPlugins = this.UseLocalPlugins;
         hiveExperiment.ResourceNames = this.ResourceNames;
+        hiveExperiment.IsPrivileged = this.IsPrivileged;
         var refreshableHiveExperiment = new RefreshableHiveExperiment(hiveExperiment);
         refreshableHiveExperiment.IsControllable = false;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/Tests/Program.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/Tests/Program.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/Tests/Program.cs	(revision 6381)
@@ -47,5 +47,5 @@
       GeneticAlgorithm alg = new GeneticAlgorithm();
       alg.Problem = new SingleObjectiveTestFunctionProblem();
-      alg.Engine = new HiveEngine() { ResourceNames = "CHRISTOPH-PC" };
+      alg.Engine = new HiveEngine() { ResourceNames = "HEAL" };
       alg.Elites.Value = 0;
       alg.PopulationSize.Value = 10;
